LeetCode in Kotlin

1883. Minimum Skips to Arrive at Meeting On Time

Hard

You are given an integer hoursBefore, the number of hours you have to travel to your meeting. To arrive at your meeting, you have to travel through n roads. The road lengths are given as an integer array dist of length n, where dist[i] describes the length of the ith road in kilometers. In addition, you are given an integer speed, which is the speed (in km/h) you will travel at.

After you travel road i, you must rest and wait for the next integer hour before you can begin traveling on the next road. Note that you do not have to rest after traveling the last road because you are already at the meeting.

However, you are allowed to skip some rests to be able to arrive on time, meaning you do not need to wait for the next integer hour. Note that this means you may finish traveling future roads at different hour marks.

Return the minimum number of skips required to arrive at the meeting on time, or -1 if it is impossible.

Example 1:

Input: dist = [1,3,2], speed = 4, hoursBefore = 2

Output: 1

Explanation:

Without skipping any rests, you will arrive in (1/4 + 3/4) + (3/4 + 1/4) + (2/4) = 2.5 hours.

You can skip the first rest to arrive in ((1/4 + 0) + (3/4 + 0)) + (2/4) = 1.5 hours.

Note that the second rest is shortened because you finish traveling the second road at an integer hour due to skipping the first rest.

Example 2:

Input: dist = [7,3,5,5], speed = 2, hoursBefore = 10

Output: 2

Explanation:

Without skipping any rests, you will arrive in (7/2 + 1/2) + (3/2 + 1/2) + (5/2 + 1/2) + (5/2) = 11.5 hours.

You can skip the first and third rest to arrive in ((7/2 + 0) + (3/2 + 0)) + ((5/2 + 0) + (5/2)) = 10 hours.

Example 3:

Input: dist = [7,3,5,5], speed = 1, hoursBefore = 10

Output: -1

Explanation: It is impossible to arrive at the meeting on time even if you skip all the rests.

Constraints:

Solution

class Solution {
    fun minSkips(dist: IntArray, speed: Int, hoursBefore: Int): Int {
        val len = dist.size
        // dp[i][j] finish ith road, skip j times;
        val dp = Array(len) { IntArray(len) }
        dp[0][0] = dist[0]
        for (i in 1 until len) {
            dp[i][0] = (dp[i - 1][0] + speed - 1) / speed * speed + dist[i]
        }
        for (i in 1 until len) {
            for (j in 0..i) {
                if (j > 0) {
                    dp[i][j] = dp[i - 1][j - 1] + dist[i]
                }
                if (j <= i - 1) {
                    dp[i][j] = Math.min(
                        dp[i][j], (dp[i - 1][j] + speed - 1) / speed * speed + dist[i]
                    )
                }
            }
        }
        for (i in 0 until len) {
            if (dp[len - 1][i] <= speed.toLong() * hoursBefore) {
                return i
            }
        }
        return -1
    }
}